import numpy as np                   
class Peak(object):
    def __init__(self, x, y, lefttr, righttr, maxwidth, num, minheightlr):
        self.x = x
        self.y = y
        self.ltr = lefttr
        self.rtr = righttr
        self.maxwidth = maxwidth
        self.minheightlr = minheightlr
        self.distancetoltr = self.distancetoltr()
        self.distancetortr = self.distancetortr()
        self.nexttrdistance = self.nexttrdistance()
        self.pccl = -1
        self.real = True
        self.isreal()
        # find peaks with a trough in a distance less than maxwidth
        if self.real:
            if self.distancetoltr is not None and self.distancetortr is not None:
                if self.distancetoltr < self.maxwidth and self.distancetortr < self.maxwidth:
                    self.width = self.distancetoltr + self.distancetortr

                else: self.width = self.nexttrdistance
            elif self.nexttrdistance is None:
                self.real = False
            else: self.width = self.nexttrdistance
        self.height = self.y
        self.calcheight()
        #self.cutsize = len(cut)
        #self.cut = cut
        self.currentclass = 0
        self.cl = 0
        self.num = num
        self.relcutcenter = 0
        #self.cutaligned = cut
        self.pc1 = 0
        self.pc2 = 0
        self.noise = False
        
    def distancetoltr(self):
        if self.ltr is not None:
             return self.x - self.ltr.x
        else:
             return None

    def distancetortr(self):
        if self.rtr is not None:     
            return self.rtr.x - self.x
        else:
             return None
    
    def nexttrdistance(self):
        if self.distancetoltr is not None and self.distancetortr is not None:
            return min(self.distancetoltr, self.distancetortr)
        elif self.distancetoltr is None:
            return self.distancetortr
        else: return self.distancetoltr
        
    def isreal(self):
        if self.nexttrdistance is not None:
            if self.nexttrdistance < self.maxwidth:
                self.real =  True
            else:
                self.real = False
        else: self.real = False
    
    def isreal_nowave(self, mhlr):
       # print(mhlr)
        if mhlr < self.height *0.1:
            self.real = False

    def isreal_pleateaupeaks(self):
          self.isreal_nowave(self.minheightlr)
          
        
    def calcheight(self):
        if self.real:
            if self.ltr is not None and self.rtr is not None:
                if self.distancetoltr < self.maxwidth and self.distancetortr < self.maxwidth:
                    self.height = self.y - min(self.ltr.y,self.rtr.y)
                 
                elif self.distancetoltr < self.maxwidth:
                    self.height = self.y - self.ltr.y
                elif self.distancetortr < self.maxwidth:
                    self.height = self.y - self.rtr.y
            elif self.ltr is not None:
                if self.distancetoltr < self.maxwidth:
                    self.height = self.y - self.ltr.y
            else:
                self.height = self.y - self.rtr.y
      
        if not hasattr(self, 'height'):
            self.height = self.y

    def calcwidth(self):
        if self.isreal:
            self.width = self.nexttrdistance

class Tr(object):
    def __init__(self, x, y): 
        self.x = x
        self.y = y

    def gety(self):
        return self.y
    def getx(self):
        return self.x

class Peaklist(object):
    def __init__(self, peaklist):
        self.list = peaklist
        self.lastofclass = {}
        self.lastofclassx = {}
        self.classesnearby = []
        self.classesnearbyx = []
        self.classesnearbypccl = []
        self.classlist = []
        self.classamount = 0
        self.shapes = {}
